# CIRAD
# Mézino Mickaël - Février 2021 / janvier 2022 / Mai 2022

from webservice_smartis_general import *

start_date = "2010-01-01"
end_date = "2019-12-31"
latitude = "-21.27657804234913"
longitude = "55.39031982421876"
altitude = "70"

# pour la fréquence H=Horaire et Q=Quotidien
frequence = "Q" 
parametres = "rr|glot"
id_station = "97103403"  # Exemple de station en Guadeloupe : Vieux Habitant
header = '0'
# username correspond à l'identifiant utilisé pour vous connecter à https://smartis.re 
# username exemple : username = 'mezino'
# passwd correspond à la version cryptée du mot de passe. Pour obternir la chaine crypter de votre mot de passe 
# visitez https://smartis.re/WEBSERVICES 
# cliquer sur "Comment crypter son mot de passe" puis dans la zone de saisie tapez votre mot de passe en clair puis cliquer sur 'Crypter'
# la chaine obtenu ressemble à (version crypter du mot monpassword):
# 8af824f268bb9cd653078942a127eb8dc697bd1012399265acbd1f15f17cf02552a5107845561b7b827497e9c4f7bbc0ae878e53bd59b5e1567ca7d1ca28f56c

# EXEMPLE (Attention mot de passe haché exemple non fonctionnel): 
credential = get_credential('username','8af824f268bb9cd653078942a127eb8dc697bd1012399265acbd1f15f17cf02552a5107845561b7b827497e9c4f7bbc0ae878e53bd59b5e1567ca7d1ca28f56c')



if credential != -1:
    #print("geo_data =", ws_geo_meteo(credential,start_date,end_date,latitude,longitude) )
    #print("freq_data =", ws_meteo_frequency(credential,latitude,longitude,altitude,'2020-01-01','2020-12-31'))
    print("station_data_q =", ws_station_meteo(credential,id_station,start_date,end_date,parametres,'Q'))
    print("station_data_h =", ws_station_meteo(credential,id_station,start_date,end_date,parametres,'H'))
    #
    print("data sur grid 3x3=",ws_data_grid(credential,latitude,longitude,"2015-01-01","2015-01-03"))
    ru = ws_ru(credential,latitude,longitude,'dd')
    if ru == 999:
        print("Terre inculte")
    else:
        print("Reserve utile (mm) =",ru)
    variete = choix_variete('R585')
    print(ws_mosicas(credential,latitude,longitude,'2018-07-01','2019-06-30','50','.5',str(ru[1][0]),'1','5',variete,'1','0','0','400','1','70'))
    #print(ws_mosicas_grid(credential,latitude,longitude,'2018-07-01','2019-06-30','50','.5',str(ru[1][0]),'1','5',variete,'1','0','0','400'))
    data=ws_data_grid(credential,latitude,longitude,'2000-01-01','2010-12-31')
    mod=ws_mosicas_grid(credential,latitude,longitude,'2018-07-01','2019-06-30','50','.5',str(ru[1][0]),'1','5',variete,'1','0','0','400')
    mod=ws_mosicas_grid(credential,latitude,longitude,'2051-07-01','2052-06-30','50','.5',str(ru[1][0]),'1','5',variete,'1','0','0','400',code_scenario('ssp126'))
    print("Rendement de canne à sucre avec le scénario ssp126 pour la campagne 2051:",mod[1][21])
    mod=ws_mosicas_grid(credential,latitude,longitude,'2051-07-01','2052-06-30','50','.5',str(ru[1][0]),'1','5',variete,'1','0','0','400',code_scenario('ssp245'))
    print("Rendement de canne à sucre avec le scénario ssp245 pour la campagne 2051:",mod[1][21])
    mod=ws_mosicas_grid(credential,latitude,longitude,'2051-07-01','2053-06-30','50','.5',str(ru[1][0]),'1','5',variete,'1','0','0','400',code_scenario('ssp585'))
    print("Rendement de canne à sucre avec le scénario ssp585 pour la campagne 2051:",mod[1][21])
    mod=ws_mosicas_grid(credential,latitude,longitude,'2004-07-01','2005-06-30','50','.5',str(ru[1][0]),'1','5',variete,'1','0','0','400',code_scenario('hist'))
    print("Rendement de canne à sucre avec les données historique pour la campagne 2005:",mod[1][21])
    mod=ws_mosicas_grid(credential,latitude,longitude,'2004-07-01','2005-06-30','50','.5',str(ru[1][0]),'1','5',variete,'1','0','0','400',code_scenario('ref'))
    print("Rendement de canne à sucre avec les données référence pour la campagne 2005:",mod[1][21])
    latitude='-21.34886257728332'
    longitude='55.524215698242195'
    # Exemple avec irrigation : 
    mod=ws_mosicas_grid(credential,latitude,longitude,'2051-07-01','2052-06-30','50','.5',str(ru[1][0]),'1','10',variete,'1','25','7','400','1','70',code_scenario('ssp585'))
      # Récupération de donnée par MF :
    #print("Data CNA:",ws_mf_meteo(credential,id_station,start_date,end_date,header))
   # print('info scenario, code ssp126',choix_scenario('ssp126'))
    print('code scenario ssp126 :',code_scenario('ssp245'))
    #print("data brio ssp126:", ws_brio_data(credential,latitude,longitude,"2050-01-01","2050-01-03","ssp126"))
    #print('info scenario, code ssp245',choix_scenario('ssp245'))
    #print("data brio ssp245:",ws_brio_data(credential,latitude,longitude,"2050-01-01","2050-01-03","ssp245"))
    #print('info scenario code ssp585',choix_scenario('ssp585'))
    #print("data brio ssp585:", ws_brio_data(credential,latitude,longitude,"2050-01-01","2050-01-03","ssp585"))
else:
    print("Erreur de login ou de mot de passe.")
